#include <config.h>

#include "messages.h"
#include "ftpd.h"
#include "caps_p.h"
#ifdef WITH_DMALLOC
# include <dmalloc.h>
#endif

#ifdef USE_CAPABILITIES
void drop_login_caps(void)
{
	cap_t caps = cap_init();

	if (!caps ||
		-1 == cap_clear(caps) ||
		-1 == cap_set_flag(caps, CAP_PERMITTED,
						   sizeof(cap_keep_login) / sizeof(cap_value_t),
						   cap_keep_login, CAP_SET) ||
		-1 == cap_set_flag(caps, CAP_EFFECTIVE,
						   sizeof(cap_keep_login) / sizeof(cap_value_t),
						   cap_keep_login, CAP_SET) ||
		-1 == cap_set_proc(caps) ||
		-1 == cap_free(caps)) {
		die(421, LOG_ERR, MSG_CAPABILITIES " : %s" , strerror(errno));
	}
}

void set_initial_caps(void)
{
	cap_t caps = cap_init();
	
	if (!caps ||
		-1 == cap_clear(caps) ||
		-1 == cap_set_flag(caps, CAP_PERMITTED,
						   sizeof(cap_keep_startup) / sizeof(cap_value_t),
						   cap_keep_startup, CAP_SET) ||
		-1 == cap_set_flag(caps, CAP_EFFECTIVE,
						   sizeof(cap_keep_startup) / sizeof(cap_value_t),
						   cap_keep_startup, CAP_SET) ||
		-1 == cap_set_proc(caps) ||
		-1 == cap_free(caps)) {
		die(421, LOG_ERR, MSG_CAPABILITIES ": %s" , strerror(errno));
	}
}
#else
extern signed char v6ready;
#endif
