#include <config.h>

#if !defined(NO_INETD) || defined(__PURE_MRTGINFO_C__)
# include "ftpd.h"
# ifdef WITH_DMALLOC
#  include <dmalloc.h>
# endif

# define TCP_STATE_CNX 1UL

static int count(unsigned short server_port,
				 const char * const file)
{
	int f;
	int r;
	int b = 0, e = 0;
	int c;
	int d = 0;
	char buf[2049];	

	f = open(file, O_RDONLY);
	if (f < 0) {
		return 0;
	}
	buf[2048] = 0;
	
	for (;;) {
		r = read(f, buf + e, 2048 - e);
		if (r <= 0)				/* ignore errors.  0 is okay, in fact common. */
			break;
		e += r;

		/* b now is offset of the start of the first line to be parsed
		   and e the end of the available data */
		c = b;
		while (c < e && buf[c] != '\n')
			c++;
		while (c < e) {
			buf[c++] = 0;
			while (b < c && buf[b] != ':' && buf[b] != '\n')
				b++;
			if (b < c && buf[b] == ':') {
				b++;
				while (b < e && buf[b] != ':')
					b++;
				b++;
				if (strtoul(buf + b, NULL, 16) ==
					(unsigned long) server_port) {
					while (b < e && buf[b] != ':')
						b++;
					if (buf[b] == ':') {
						b++;
						while (b < e && buf[b] != ' ')
							b++;
						if (buf[b] == ' ') {
							b++;
							if (strtoul(buf + b, NULL, 16) == TCP_STATE_CNX) {
								d++;
							}
						}
					}
				}
			}
			b = c;
			while (c < e && buf[c] != '\n')
				c++;
		}
		if (e > b)
			(void) memmove(buf, buf + b, e - b);
		e = e - b;
		b = 0;
	}
	close(f);
	
	return d;
}

int daemons(const unsigned short server_port)
{
	int nbcnx;
	
	nbcnx = count(server_port, "/proc/net/tcp");
	nbcnx += count(server_port, "/proc/net/tcp6");
	
	return nbcnx;
}
#else
extern signed char v6ready;
#endif
