#ifndef __FTPWHO_UPDATE_H__
#define __FTPWHO_UPDATE_H__ 1

#ifdef FTPWHO

typedef enum {
	FTPWHO_STATE_FREE = 0, 				   /* must be first (0) */
		FTPWHO_STATE_IDLE, FTPWHO_STATE_DOWNLOAD, FTPWHO_STATE_UPLOAD
} FTPWhoEntryState;

typedef struct FTPWhoEntry_ {
	FTPWhoEntryState state;		
	pid_t pid;
	struct sockaddr_storage addr;
	struct sockaddr_storage local_addr;	
	time_t date;
	time_t xfer_date;
	char account[9];
	char filename[43];
	volatile off_t restartat;
	volatile off_t download_total_size;
	volatile off_t download_current_size;
} FTPWhoEntry;

#ifndef FTPWHO_KEY
# define FTPWHO_KEY ((key_t) 0x6942) 
#endif

int ftpwho_initwho(const int create, size_t * const shm_size);
void ftpwho_exit(const int ret);
void ftpwho_lock(void);
void ftpwho_unlock(void);
	
#endif

#endif
