#include <config.h>

#define __PURE_MRTGINFO_C__ 1


#include <stdio.h>
#ifdef STDC_HEADERS
# include <stdlib.h>
# include <stddef.h>
# include <stdarg.h>
#else
# if HAVE_STDLIB_H
#  include <stdlib.h>
# endif
#endif
#if HAVE_STRING_H
# if !STDC_HEADERS && HAVE_MEMORY_H
#  include <memory.h>
# endif
# include <string.h>
#else
# if HAVE_STRINGS_H
#  include <strings.h>
# endif
#endif
#if HAVE_INTTYPES_H
# include <inttypes.h>
#endif
#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "ftpd.h"

#ifdef NO_INETD
# include "daemons.c"
#endif
#ifdef WITH_DMALLOC
# include <dmalloc.h>
#endif

static const char *uptime(void)
{
	int f;
	int r;
	unsigned long u;
	char buf[1025];	

	f = open("/proc/uptime", O_RDONLY);
	if (f < 0)
		return "?";

	r = read(f, buf, sizeof buf - 1U);
	if (r <= 0)
		return "?";
	close(f);

	u = strtoul(buf, NULL, 10);
	if (snprintf(buf, sizeof buf, "%lu days, %lu:%02lu:%02lu",
				 u / 86400, u / 3600 % 24, u / 60 % 60, u % 60) <= 0) {
		_exit(EXIT_FAILURE);
	}
	return strdup(buf);
}

static const char *name(void)
{
	int f;
	int r;
	char buf[1025];	

	f = open("/proc/sys/kernel/hostname", O_RDONLY);
	if (f < 0) {
		return "?";
	}
	r = read(f, buf, sizeof buf - 1U);
	if (r <= 0) {
		return "?";
	}
	close(f);

	buf[r] = 0;
	while (r && isspace(buf[r - 1])) {
		buf[--r] = 0;
	}
	return strdup(buf);
}

int main(int argc, char *argv[])
{
	int d;
	unsigned short server_port = 21U;

	if (argc == 2) {
		server_port = (unsigned short) strtoul(argv[1], NULL, 10);
	}
	d = daemons(server_port);
	printf("%d\n%d\n%s\n%s\n", d, d, uptime(), name());
	return 0;
}
